<?php
if(empty($GLOBALS['sugarEntry'])) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/
// $Id : Save.php, v 1.47 2005 / 08 / 13 00: 03:34 andrew Exp $
//_ppd($_REQUEST);
require_once('modules/Emails/Email.php');
require_once('include/TimeDate.php');

global $mod_strings;


///////////////////////////////////////////////////////////////////////////////
////	EMAIL SEND/SAVE SETUP
$focus = new Email();
$timedate = new TimeDate();

if(!isset($prefix)) {
	$prefix = '';
}
if(isset($_POST[$prefix.'meridiem']) && !empty($_POST[$prefix.'meridiem'])) {
	$_POST[$prefix.'time_start'] = $timedate->merge_time_meridiem($_POST[$prefix.'time_start'], $timedate->get_time_format(true), $_POST[$prefix.'meridiem']);
}

//retrieve the record
if(isset($_POST['record'])) {
	$focus->retrieve($_POST['record']);
}
if(!$focus->ACLAccess('Save')){
		ACLController::displayNoAccess(true);
		sugar_cleanup(true);
}
if(!empty($_POST['assigned_user_id']) && ($focus->assigned_user_id != $_POST['assigned_user_id']) && ($_POST['assigned_user_id'] != $current_user->id)) {
	$check_notify = TRUE;
}
//populate the fields of this Email
$allfields = array_merge($focus->column_fields, $focus->additional_column_fields);
foreach($allfields as $field) {
	if(isset($_POST[$field])) {
		$value = $_POST[$field];
		$focus->$field = $value;
	}
}
//compare the 3 fields and return list of contact_ids to link:
$focus->to_addrs_arr = $focus->parse_addrs($_REQUEST['to_addrs'], $_REQUEST['to_addrs_ids'], $_REQUEST['to_addrs_names'], $_REQUEST['to_addrs_emails']);
$focus->cc_addrs_arr = $focus->parse_addrs($_REQUEST['cc_addrs'], $_REQUEST['cc_addrs_ids'], $_REQUEST['cc_addrs_names'], $_REQUEST['cc_addrs_emails']);
$focus->bcc_addrs_arr = $focus->parse_addrs($_REQUEST['bcc_addrs'], $_REQUEST['bcc_addrs_ids'], $_REQUEST['to_addrs_names'], $_REQUEST['bcc_addrs_emails']);

if(!empty($_REQUEST['type'])) {
	$focus->type = $_REQUEST['type'];
} else {
	$focus->type = 'archived';
}

$object_arr = array();
if(!empty($focus->parent_id)) {
	$object_arr[$focus->parent_type] = $focus->parent_id;
}
if(isset($focus->to_addrs_arr[0]['contact_id'])) {
	$object_arr['Contacts'] = $focus->to_addrs_arr[0]['contact_id'];
}
// do not parse email templates if the email is being saved as draft....
if($focus->type != 'draft') {
	require_once($beanFiles['EmailTemplate']);
	$focus->name = EmailTemplate::parse_template($focus->name, $object_arr);
	if(empty($focus->description)) {
		$focus->description = strip_tags(from_html($focus->description_html));
	}
	$focus->description = EmailTemplate::parse_template($focus->description, $object_arr);
	$focus->description_html = EmailTemplate::parse_template($focus->description_html, $object_arr);
}
$focus->to_addrs = $_REQUEST['to_addrs'];
$focus->save(FALSE);
$focus->retrieve($focus->id);


//_pp('id at first save: '.$focus->id);


///////////////////////////////////////////////////////////////////////////////
////	ATTACHMENT HANDLING
	///////////////////////////////////////////////////////////////////////////
	////	ATTACHMENTS FROM TEMPLATES
	// to preserve individual email integrity, we must dupe Notes and associated files
	// for each outbound email - good for integrity, bad for filespace
	if(isset($_REQUEST['template_attachment']) && !empty($_REQUEST['template_attachment'])) {
		$removeArr = array();
		$noteArray = array();
		
		if(isset($_REQUEST['temp_remove_attachment']) && !empty($_REQUEST['temp_remove_attachment'])) {
			$removeArr = $_REQUEST['temp_remove_attachment'];
		}
		
		foreach($_REQUEST['template_attachment'] as $noteId) {
			if(in_array($noteId, $removeArr)) {
				continue;
			}
			$noteTemplate = new Note();
			$noteTemplate->retrieve($noteId);
			$noteTemplate->id = create_guid();
			$noteTemplate->new_with_id = true; // duplicating the note with files
			$noteTemplate->parent_id = $focus->id;
			$noteTemplate->parent_type = $focus->module_dir;
			$noteTemplate->save();
			
			$noteFile = new UploadFile('none');
			$noteFile->duplicate_file($noteId, $noteTemplate->id, $noteTemplate->filename);
			$noteArray[] = $noteTemplate;
		}
//		$focus->attachments = array_merge($focus->attachments, $noteArray);
	}
	////	END ATTACHMENTS FROM TEMPLATES
	///////////////////////////////////////////////////////////////////////////

	///////////////////////////////////////////////////////////////////////////
	////	ADDING NEW ATTACHMENTS
	$max_files_upload = 10;
	if(!empty($focus->id) && !$focus->new_with_id) {
		$note = new Note();
		$where = "notes.parent_id='{$focus->id}'";
		$notes_list = $note->get_full_list("", $where, true);
	}

	if(!isset($notes_list)) {
		$notes_list = array();
	}

	$focus->attachments = array_merge($focus->attachments, $notes_list);

	for($i = 0; $i < $max_files_upload; $i++) {
		$note = new Note();
		$upload_file = new UploadFile('email_attachment'.$i);

		if($upload_file == -1) {
			continue;
		}

		if(isset($_FILES['email_attachment'.$i]) && $upload_file->confirm_upload()) {
			$note->filename = $upload_file->get_stored_file_name();
			$note->file = $upload_file;
			$note->name = $mod_strings['LBL_EMAIL_ATTACHMENT'].': '.$note->file->original_file_name;




			array_push($focus->attachments, $note);
		}
	}

	$focus->saved_attachments = array();
	foreach($focus->attachments as $note) {
		if(!empty($note->id)) {
			array_push($focus->saved_attachments, $note);
			continue;
		}
		$note->parent_id = $focus->id;
		$note->parent_type = 'Emails';
		$note->file_mime_type = $note->file->mime_type;
		$note_id = $note->save();
		array_push($focus->saved_attachments, $note);
		$note->id = $note_id;
		$note->file->final_move($note->id);
	}

	////	END NEW ATTACHMENTS
	///////////////////////////////////////////////////////////////////////////

	///////////////////////////////////////////////////////////////////////////
	////	REMOVE ATTACHMENTS

	if(isset($_REQUEST['remove_attachment']) && !empty($_REQUEST['remove_attachment'])) {
		foreach($_REQUEST['remove_attachment'] as $noteId) {
			$q = 'UPDATE notes SET deleted = 1 WHERE id = \''.$noteId.'\'';
			$focus->db->query($q);
		}

	}

	////	END REMOVE ATTACHMENTS
	///////////////////////////////////////////////////////////////////////////
////	END ATTACHMENT HANDLING
///////////////////////////////////////////////////////////////////////////////


$focus->status= 'draft';
if($focus->type == 'archived' ) {
	$focus->status= 'archived';
} elseif($focus->type == 'out' && isset($_REQUEST['send']) && $_REQUEST['send'] == '1') {
	///////////////////////////////////////////////////////////////////////////
	////	REPLY PROCESSING
	$old = array('&lt;','&gt;');
	$new = array('<','>');
	if($_REQUEST['from_addr'] != $_REQUEST['from_addr_name'].' &lt;'.$_REQUEST['from_addr_email'].'&gt;') {
		if(false === strpos($_REQUEST['from_addr'], '&lt;')) { // we have an email only?
			$focus->from_addr = $_REQUEST['from_addr'];
			$focus->from_name = '';
		} else { // we have a compound string
			$newFromAddr =  str_replace($old, $new, $_REQUEST['from_addr']);
			$focus->from_addr = substr($newFromAddr, (1 + strpos($newFromAddr, '<')), (strpos($newFromAddr, '>') - strpos($newFromAddr, '<')) -1 );
			$focus->from_name = substr($newFromAddr, 0, (strpos($newFromAddr, '<') -1));
		}
	} elseif(!empty($_REQUEST['from_addr_email']) && isset($_REQUEST['from_addr_email'])) {
		$focus->from_addr = $_REQUEST['from_addr_email'];
		$focus->from_name = $_REQUEST['from_addr_name'];
	} else {
		$focus->from_addr = $focus->getSystemDefaultEmail();
	}
	////	REPLY PROCESSING
	///////////////////////////////////////////////////////////////////////////
	if($focus->send()) {
		///////////////////////////////////////////////////////////////////////
		////	INBOUND EMAIL HANDLING
		// mark replied
		// MOVED TO SEND() METHOD
		//if(!empty($_REQUEST['inbound_email_id'])) {
		//	$ieMail = new Email();
		//	$ieMail->retrieve($_REQUEST['inbound_email_id']);
		//	$ieMail->status = 'replied';
		//	$ieMail->save();
		//}
		////	END INBOUND EMAIL HANDLING
		///////////////////////////////////////////////////////////////////////

		$focus->status = 'sent';
		$focus->date_start = $timedate->to_display_date(date('Y-m-d'),false);
  		$focus->time_start = $timedate->to_display_time(date('H:i:s'), true, false);
	} else {
		$focus->status = 'send_error';
	}
}
////	END EMAIL SAVE/SEND SETUP
///////////////////////////////////////////////////////////////////////////////


if(!empty($GLOBALS['check_notify'])) {
	$focus->save($GLOBALS['check_notify']);
} else {
	$focus->save(FALSE);
}

///////////////////////////////////////////////////////////////////////////////
////	CONTACT RELATIONSHIP SETUP
///////////////////////////////////////////////////////////////////////////////
$return_id = $focus->id;
$seen_contact_ids = array();
$all_arr = array_merge($focus->to_addrs_arr, $focus->cc_addrs_arr, $focus->bcc_addrs_arr);
reset($all_arr);
$contacts_list = $focus->get_contacts();
foreach($contacts_list as $contact) {
	$seen_contact_ids[$contact->id] = 1;
}

$originalSaved = false;
foreach($all_arr as $subarr) {
	if(!isset($subarr['contact_id']) || isset($seen_contact_ids[$subarr['contact_id']])) {
		continue;
	} else {
		$seen_contact_ids[$subarr['contact_id']] = 1;
		if($originalSaved) {
			$focus->id = create_guid();
			$focus->new_with_id = true;
		}
		$focus->save();
		$focus->set_emails_contact_invitee_relationship($focus->id, $subarr['contact_id']);
		$originalSaved = true;
	}
}


///////////////////////////////////////////////////////////////////////////////
////	PAGE REDIRECTION
///////////////////////////////////////////////////////////////////////////////
if(empty($_POST['return_module'])) {
	$return_module = "Emails";
} else {
	$return_module = $_POST['return_module'];
}
if(empty($_POST['return_action'])) {
	$return_action = "DetailView";
} else {
	$return_action = $_POST['return_action'];
}
$GLOBALS['log']->debug("Saved record with id of ".$return_id);
require_once('include/formbase.php');

if($focus->type == 'draft') {
	if($return_module == 'Emails') {
		header("Location: index.php?module=$return_module&action=ListViewDrafts");
	} else {
		handleRedirect($return_id, 'Emails');
	}
} elseif($focus->type == 'out') {
	if($return_module == 'Home') {
		header('Location: index.php?module='.$return_module.'&action=index');
	}
	if(!empty($_REQUEST['return_id'])) {
		$return_id = $_REQUEST['return_id'];
	}
	header('Location: index.php?action='.$return_action.'&module='.$return_module.'&record='.$return_id.'&assigned_user_id='.$current_user->id.'&type=inbound');
} elseif(isset($_POST['return_id']) && $_POST['return_id'] != "") {
	$return_id = $_POST['return_id'];
}
	header("Location: index.php?action=$return_action&module=$return_module&record=$return_id");
?>
